com.smartgwt.client.util.workflow

## Class ComponentTask

- java.lang.Object
- - com.smartgwt.client.core.BaseClass
  - - com.smartgwt.client.util.workflow.ProcessElement
    - - com.smartgwt.client.util.workflow.ComponentTask

- All Implemented Interfaces:
    com.google.gwt.event.shared.HasHandlers
  Direct Known Subclasses:
    AddScreenTask, FetchRelatedDataTask, FormClearValuesTask, FormDisableFieldTask, FormEditNewRecordTask, FormEditSelectedTask, FormResetValuesTask, FormSaveDataTask, FormSetFieldValueTask, FormSetValuesTask, FormValidateValuesTask, GetPropertiesTask, GridEditRecordTask, GridExportClientDataTask, GridExportDataTask, GridFetchDataTask, GridRemoveSelectedDataTask, GridSaveAllEditsTask, GridSelectRecordsTask, GridSetEditValueTask, GridTransferDataTask, GridViewSelectedDataTask, NavigateSplitPaneTask, PrintCanvasTask, SetPropertiesTask, SetScreenDataTask, SetTitleTask, ShowComponentTask, ShowHideTask, ShowNextToComponentTask

      public class ComponentTask
      extends ProcessElement

  Base class for tasks that target SmartGWT UI-specific operations.

  Note: This task is not for direct use - use one of the subclasses instead.

- - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.core.BaseClass

      `config, configOnly, factoryCreated, factoryProperties, id, scClassName`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ComponentTask()`
    `ComponentTask(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.google.gwt.core.client.JavaScriptObject` | `create()`
    `java.lang.String` | `getComponentBaseClass()` Base class of components that this task targets.
    `java.lang.String[]` | `getComponentBaseClassAsStringArray()` Base class of components that this task targets.
    `java.lang.String` | `getComponentId()` ID of component targeted by this task.
    `java.lang.Boolean` | `getComponentRequiresDataSource()` Must target components of this task have a DataSource?
    `static ComponentTask` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `java.lang.String` | `getTargetBaseClass()` Base class of components and any required or optional scope that this task targets.
    `java.lang.String[]` | `getTargetBaseClassAsStringArray()` Base class of components and any required or optional scope that this task targets.
    `void` | `getTargetComponent(Process process)` Returns the actual component specified by `componentId` for this task.
    `void` | `getTargetComponent(Process process, java.lang.Boolean skipValidation)` Returns the actual component specified by `componentId` for this task.
    `java.lang.String` | `getUnsupportedComponentMessage()` The default message to be reported with `getInvalidTaskMessage()` when a target component type is not supported for the task.
    `ComponentTask` | `setComponentBaseClass(java.lang.String... componentBaseClass)` Base class of components that this task targets.
    `ComponentTask` | `setComponentBaseClass(java.lang.String componentBaseClass)` Base class of components that this task targets.
    `ComponentTask` | `setComponentId(java.lang.String componentId)` ID of component targeted by this task.
    `ComponentTask` | `setComponentRequiresDataSource(java.lang.Boolean componentRequiresDataSource)` Must target components of this task have a DataSource?
    `ComponentTask` | `setTargetBaseClass(java.lang.String... targetBaseClass)` Base class of components and any required or optional scope that this task targets.
    `ComponentTask` | `setTargetBaseClass(java.lang.String targetBaseClass)` Base class of components and any required or optional scope that this task targets.
    `ComponentTask` | `setUnsupportedComponentMessage(java.lang.String unsupportedComponentMessage)` The default message to be reported with `getInvalidTaskMessage()` when a target component type is not supported for the task.

    - ### Methods inherited from class com.smartgwt.client.util.workflow.ProcessElement

      `completeElement, convertToJavaScriptArray, executeElement, getBindOutput, getClassDescription, getComponentReferences, getDescription, getDynamicValue, getEditorType, getElementDescription, getForceSingle, getID, getInvalidTaskMessage, getJsObj, getMockMode, getNextElement, getOrCreateJsObj, getPassThruOutput, getProcessElements, getSupportsMultipleInputRecords, getTextFormulaValue, getTypeTitle, getUndefinedComponentMessage, getUnresolvedComponentMessage, getWaitDuration, getWaitFor, getWaitLocator, isCreated, isValid, objectReferencesLastTaskOutput, onInit, reset, setAttribute, setBindOutput, setClassDescription, setDescription, setEditorType, setForceSingle, setID, setJavaScriptObject, setMockMode, setNextElement, setPassThruOutput, setSupportsMultipleInputRecords, setTypeTitle, setUndefinedComponentMessage, setUnresolvedComponentMessage, setWaitDuration, setWaitFor, setWaitLocator, updateGlobalIDInCriteria, updateGlobalIDInTextFormula, updateGlobalIDInValueProperty, updateGlobalIDInValues, updateGlobalIDReferences, updateLastElementBindingReferences, updateLastElementInCriteria, updateLastElementInValueProperty, updateLastElementInValues`

    - ### Methods inherited from class com.smartgwt.client.core.BaseClass

      `addDynamicProperty, addDynamicProperty, addDynamicProperty, addDynamicProperty, applyFactoryProperties, asSGWTComponent, clearDynamicProperty, createJsObj, destroy, doAddHandler, doInit, error, error, errorIfNotCreated, fireEvent, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsInt, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsString, getAttributeAsStringArray, getClassName, getConfig, getHandlerCount, getRef, getRuleScope, getScClassName, getTestInstance, hasAutoAssignedID, hasDynamicProperty, internalSetID, internalSetID, isConfigOnly, isFactoryCreated, onBind, registerID, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setFactoryCreated, setProperty, setProperty, setProperty, setProperty, setRuleScope, setScClassName`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ComponentTask

          public ComponentTask()

    - #### ComponentTask

          public ComponentTask(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static ComponentTask getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### create

          public com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `ProcessElement`

    - #### setComponentBaseClass

          public ComponentTask setComponentBaseClass(java.lang.String componentBaseClass)
                                              throws java.lang.IllegalStateException

      Base class of components that this task targets. The `componentId` must be an instance of one of the classes.
      Parameters:
        `componentBaseClass` - New componentBaseClass value. Default value is null
      Returns:
        `ComponentTask` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getComponentBaseClass

          public java.lang.String getComponentBaseClass()

      Base class of components that this task targets. The `componentId` must be an instance of one of the classes.
      Returns:
        Current componentBaseClass value. Default value is null

    - #### setComponentBaseClass

          public ComponentTask setComponentBaseClass(java.lang.String... componentBaseClass)
                                              throws java.lang.IllegalStateException

      Base class of components that this task targets. The `componentId` must be an instance of one of the classes.
      Parameters:
        `componentBaseClass` - New componentBaseClass value. Default value is null
      Returns:
        `ComponentTask` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getComponentBaseClassAsStringArray

          public java.lang.String[] getComponentBaseClassAsStringArray()

      Base class of components that this task targets. The `componentId` must be an instance of one of the classes.
      Returns:
        Current componentBaseClass value. Default value is null

    - #### setComponentId

          public ComponentTask setComponentId(java.lang.String componentId)
                                       throws java.lang.IllegalStateException

      ID of component targeted by this task.
      Parameters:
        `componentId` - New componentId value. Default value is null
      Returns:
        `ComponentTask` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created
      See Also:
        `GlobalId`

    - #### getComponentId

          public java.lang.String getComponentId()

      ID of component targeted by this task.
      Returns:
        Current componentId value. Default value is null
      See Also:
        `GlobalId`

    - #### setComponentRequiresDataSource

          public ComponentTask setComponentRequiresDataSource(java.lang.Boolean componentRequiresDataSource)
                                                       throws java.lang.IllegalStateException

      Must target components of this task have a DataSource?
      Parameters:
        `componentRequiresDataSource` - New componentRequiresDataSource value. Default value is null
      Returns:
        `ComponentTask` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getComponentRequiresDataSource

          public java.lang.Boolean getComponentRequiresDataSource()

      Must target components of this task have a DataSource?
      Returns:
        Current componentRequiresDataSource value. Default value is null

    - #### setTargetBaseClass

          public ComponentTask setTargetBaseClass(java.lang.String targetBaseClass)
                                           throws java.lang.IllegalStateException

      Base class of components and any required or optional scope that this task targets. The `componentId` may not be an instance itself but when combined with the additional scope (targetFieldName, targetSectionName, ...) the actual target must be an instance of one of the classes.

      This can be used by an editor to limit or verify the user's selection.

      Parameters:
        `targetBaseClass` - New targetBaseClass value. Default value is null
      Returns:
        `ComponentTask` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getTargetBaseClass

          public java.lang.String getTargetBaseClass()

      Base class of components and any required or optional scope that this task targets. The `componentId` may not be an instance itself but when combined with the additional scope (targetFieldName, targetSectionName, ...) the actual target must be an instance of one of the classes.

      This can be used by an editor to limit or verify the user's selection.

      Returns:
        Current targetBaseClass value. Default value is null

    - #### setTargetBaseClass

          public ComponentTask setTargetBaseClass(java.lang.String... targetBaseClass)
                                           throws java.lang.IllegalStateException

      Base class of components and any required or optional scope that this task targets. The `componentId` may not be an instance itself but when combined with the additional scope (targetFieldName, targetSectionName, ...) the actual target must be an instance of one of the classes.

      This can be used by an editor to limit or verify the user's selection.

      Parameters:
        `targetBaseClass` - New targetBaseClass value. Default value is null
      Returns:
        `ComponentTask` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getTargetBaseClassAsStringArray

          public java.lang.String[] getTargetBaseClassAsStringArray()

      Base class of components and any required or optional scope that this task targets. The `componentId` may not be an instance itself but when combined with the additional scope (targetFieldName, targetSectionName, ...) the actual target must be an instance of one of the classes.

      This can be used by an editor to limit or verify the user's selection.

      Returns:
        Current targetBaseClass value. Default value is null

    - #### setUnsupportedComponentMessage

          public ComponentTask setUnsupportedComponentMessage(java.lang.String unsupportedComponentMessage)
                                                       throws java.lang.IllegalStateException

      The default message to be reported with `getInvalidTaskMessage()` when a target component type is not supported for the task.
      Parameters:
        `unsupportedComponentMessage` - New unsupportedComponentMessage value. Default value is "${propertyName} '${id}' is not a supported type for this task"
      Returns:
        `ComponentTask` instance, for chaining setter calls
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getUnsupportedComponentMessage

          public java.lang.String getUnsupportedComponentMessage()

      The default message to be reported with `getInvalidTaskMessage()` when a target component type is not supported for the task.
      Returns:
        Current unsupportedComponentMessage value. Default value is "${propertyName} '${id}' is not a supported type for this task"

    - #### getTargetComponent

          public void getTargetComponent(Process process)

      Returns the actual component specified by `componentId` for this task. Unless `skipValidation` is true, the component type is validated against `componentBaseClass` and only returned if it matches. Null is returned otherwise.
      Parameters:
        `process` - the process that is handling the workflow

    - #### getTargetComponent

          public void getTargetComponent(Process process,
                                         java.lang.Boolean skipValidation)

      Returns the actual component specified by `componentId` for this task. Unless `skipValidation` is true, the component type is validated against `componentBaseClass` and only returned if it matches. Null is returned otherwise.
      Parameters:
        `process` - the process that is handling the workflow
        `skipValidation` - skip validation against componentBaseClass?